<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html
  xmlns="http://www.w3.org/1999/xhtml"
  xmlns:xi="http://www.w3.org/2001/XInclude"
  xml:lang="en">
<head>
  <title>CSS Backslash Full Disclosure - Security - HTML Purifier</title>
  <xi:include href="common-meta.xml" xpointer="xpointer(/*/node())" />
  <meta name="description" content="Full disclosure security page detailing the Shift_JIS CSS backslash attack." />
  <meta name="keywords" content="HTMLPurifier, HTML Purifier, HTML, filter, filtering, standards, compliant, 3.1.1, attack, full disclosure, xss, security, shift_jis, backslash, css" />
</head>
<body>

<xi:include href="common-header.xml" xpointer="xpointer(/*/node())" />

<div id="main">
<h1 id="title"><abbr>CSS</abbr> Backslash Full Disclosure</h1>

<div id="content">

<p>
  A poorly coded escaping algorithm for <abbr>CSS</abbr> strings
  in the <code>font-family</code> property could allow a clever attacker
  to escape from the string and execute arbitrary JavaScript via 
  <abbr>CSS</abbr>.
</p>

<p>
  This vulnerability was reported privately to the vendor by
  <a href="http://d.hatena.ne.jp/teracc/">Takeshi Terada</a>.
  No active exploits are currently known.
</p>

<h2 id="Fix">Fix</h2>

<p>
  This vulnerability was fixed in HTML Purifier 3.1.1 and 2.1.5.
</p>

<h2 id="Details">Details</h2>

<p>
  The algorithm sucked. In it's old form, it used two string replaces:
</p>

<pre><![CDATA[
$font = str_replace("'", "\\'", $font);
$font = str_replace("\n", "\\\n", $font);
]]></pre>

<p>
  ...to escape magical characters. The problem with
  this algorithm was the fact that backslashes
  were not handled; thus, by prepending a single quote with a backslash
  would break this primitive protection. A hotfix was applied for this,
  however, this broke Unicode character escapes in CSS, which take
  the form of \uXXXX.
</p>

<p>
  The final solution was to rewrite all of the escaping code to iterate
  through the value of <code>font-family</code>, performing appropriate
  tests when a backslash was encountered of the later characters, 
  and translating UTF-8 escapes to their literal equivalents.
</p>

<h2 id="History">History</h2>

<p>
  The vulnerability was reported on May 23, 2008 via email.
  Two patches were committed to fix this issue, one on
  <a href="http://repo.or.cz/w/htmlpurifier.git?a=commit;h=10530d7f815803493df150fa07080669796bd33a">May 24, 2008</a>
  and one on <a href="http://repo.or.cz/w/htmlpurifier.git?a=commit;h=bb16d8eae571dd4e30e3a62cce03d436d46cefaf">May 25, 2008</a>.
  HTML Purifier 3.1.1 was released on June 19, 2008.
</p>

</div>
</div>

</body>
</html>
